<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\AppOfflineService;
use FM\Traits\TResponse;

class AppOfflineController
{

    use TResponse;
    protected $AppOfflineService;

    public function __construct(AppOfflineService $AppOfflineService)
    {
        $this->AppOfflineService = $AppOfflineService;
    }

    public function getDadosTarefaOffline()
    {
       
        try {
            $data = $this->AppOfflineService->getDadosTarefaOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosTarefasOffline()
    {
       
        try {
            $data = $this->AppOfflineService->getFotosTarefasOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getItensTarefasOffline()
    {
        try {
            $data = $this->AppOfflineService->getItensTarefasOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // Sincronizar tela MINHAS TAREFAS

    public function syncDadosBackend(Request $request)
    {
        try {
            $data = $this->AppOfflineService->syncDadosBackEnd($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getParamOffline()
    {
        try {
            $data = $this->AppOfflineService->getParamOffline();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function parametrizacaoOfflineApp(Request $request)
    {
        try {
            $data = $this->AppOfflineService->parametrizacaoOfflineApp($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    // FUNÇÕES PARA TRATAR OS DADOS DO MIRAGE PARA SINCRONIZAR.
    public function syncDadosMirage(Request $request)
    {
        try {
            $data = $this->AppOfflineService->syncDadosMirage($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // Esta função serve pra testar se o frontend tem conexão com o backend. Caso não tenha, habilitará o MirageJs
    public function testConnection()
    {   
        $data = "OK";
        $this->sendResponse($data, 200);
    }
}
