import Vue from 'vue';
import Vuex from 'vuex';

Vue.use(Vuex);

export default new Vuex.Store({
    state: {
        routerParams: {},
        menu: JSON.parse(<string>localStorage.getItem('MENU')) || [],
        appLoginToken: '',
        appShowMenu: true,
        appShowHeader: true,
    },
    mutations: {
        setAppLoginToken: (state, token: string) => {
            state.appLoginToken = token;
        },
        setAppDisplayOptions: (state, options: any) => {
            state.appShowMenu = options.menu !== '0';
            state.appShowHeader = options.header !== '0';
        },
        setRouterParams: (state, value: any) => {
            state.routerParams = value;
            localStorage.setItem('routeParams', JSON.stringify(value));
        },
        setMenu: (state, value: any) => {
            state.menu = value;
        },
    },
    actions: {
    },
    getters: {
        routerParams: (state) => state.routerParams,
        getMenu: (state) => state.menu,
    },
});
